Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/OOO_Engine_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/OOO_Engine_allocation.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/OOO_Engine_allocation.cpp	(revision 97)
@@ -66,5 +66,5 @@
       _ALLOC2_SIGNAL_IN ( in_RENAME_NO_EXECUTE                ,"NO_EXECUTE"                ,Tcontrol_t        ,1                                    ,_param->_nb_front_end,_param->_nb_inst_decod[it1]);
       _ALLOC2_SIGNAL_IN ( in_RENAME_IS_DELAY_SLOT             ,"IS_DELAY_SLOT"             ,Tcontrol_t        ,1                                    ,_param->_nb_front_end,_param->_nb_inst_decod[it1]);
-      _ALLOC2_SIGNAL_IN ( in_RENAME_ADDRESS                   ,"ADDRESS"                   ,Tgeneral_data_t   ,_param->_size_instruction_address    ,_param->_nb_front_end,_param->_nb_inst_decod[it1]);
+      _ALLOC2_SIGNAL_IN ( in_RENAME_ADDRESS                   ,"ADDRESS"                   ,Taddress_t        ,_param->_size_instruction_address    ,_param->_nb_front_end,_param->_nb_inst_decod[it1]);
       _ALLOC2_SIGNAL_IN ( in_RENAME_HAS_IMMEDIAT              ,"HAS_IMMEDIAT"              ,Tcontrol_t        ,1                                    ,_param->_nb_front_end,_param->_nb_inst_decod[it1]);
       _ALLOC2_SIGNAL_IN ( in_RENAME_IMMEDIAT                  ,"IMMEDIAT"                  ,Tgeneral_data_t   ,_param->_size_general_data           ,_param->_nb_front_end,_param->_nb_inst_decod[it1]);
@@ -124,5 +124,5 @@
       _ALLOC2_SIGNAL_IN ( in_EXECUTE_LOOP_EXCEPTION           ,"EXCEPTION"                 ,Texception_t      ,_param->_size_exception              ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
       _ALLOC2_SIGNAL_IN ( in_EXECUTE_LOOP_NO_SEQUENCE         ,"NO_SEQUENCE"               ,Tcontrol_t        ,1                                    ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
-      _ALLOC2_SIGNAL_IN ( in_EXECUTE_LOOP_ADDRESS             ,"ADDRESS"                   ,Tgeneral_data_t   ,_param->_size_general_data           ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
+      _ALLOC2_SIGNAL_IN ( in_EXECUTE_LOOP_ADDRESS             ,"ADDRESS"                   ,Taddress_t        ,_param->_size_instruction_address    ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
       _ALLOC2_SIGNAL_IN ( in_EXECUTE_LOOP_DATA                ,"DATA"                      ,Tgeneral_data_t   ,_param->_size_general_data           ,_param->_nb_execute_loop,_param->_nb_inst_execute[it1]);
     }
@@ -184,5 +184,5 @@
       ALLOC_SIGNAL_OUT  (out_COMMIT_EVENT_ADDRESS_EPCR        ,"ADDRESS_EPCR"              ,Taddress_t        ,_param->_size_instruction_address    );
       ALLOC_SIGNAL_OUT  (out_COMMIT_EVENT_ADDRESS_EEAR_VAL    ,"ADDRESS_EEAR_VAL"          ,Tcontrol_t        ,1                                    );
-      ALLOC_SIGNAL_OUT  (out_COMMIT_EVENT_ADDRESS_EEAR        ,"ADDRESS_EEAR"              ,Taddress_t        ,_param->_size_general_data           );
+      ALLOC_SIGNAL_OUT  (out_COMMIT_EVENT_ADDRESS_EEAR        ,"ADDRESS_EEAR"              ,Tgeneral_data_t   ,_param->_size_general_data           );
     }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/Parameters_print.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_OOO_Engine/OOO_Engine/src/Parameters_print.cpp	(revision 97)
@@ -63,5 +63,5 @@
     for (uint32_t i=0; i<_nb_inst_issue ; ++i)
     for (uint32_t j=0; j<_nb_type; ++j)
-    str+= toString(MSG_INFORMATION)+"   * table_issue_type                   ["+toString(i)+"]["+toString_type(j)+"] : "+toString<bool             >(_table_issue_type [i][j]          )+"\n";//[nb_inst_issue][nb_type]
+    str+= toString(MSG_INFORMATION)+"   * table_issue_type                   ["+toString(i)+"]["+toString(j)+"] : "+toString<bool             >(_table_issue_type [i][j]          )+"\n";//[nb_inst_issue][nb_type]
     str+= toString(MSG_INFORMATION)+"   * size_reexecute_queue             : "+toString<uint32_t         >(_size_reexecute_queue             )+"\n";
     str+= toString(MSG_INFORMATION)+"   * reexecute_priority               : "+toString<Tpriority_t      >(_reexecute_priority               )+"\n";
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-min.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-min.cfg	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-min.cfg	(revision 97)
@@ -7,4 +7,5 @@
 2	2	+1	# ras_size_queue                          [0]       [nb_thread]                                  
 1	1	+1	# upt_size_queue                          [0]       [nb_thread]                                  
+1	1	+1	# ufpt_size_queue                         [0]       [nb_thread]                                  
 1	1	+1	# nb_decod_bloc                                                                           
 1	1	+1	# size_decod_queue                        [0]       [nb_decod_bloc]                              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-w1a.cfg
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-w1a.cfg	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/config-w1a.cfg	(revision 97)
@@ -7,4 +7,5 @@
 4	4	+1	# ras_size_queue                          [0]       [nb_thread]                                  
 4	4	+1	# upt_size_queue                          [0]       [nb_thread]                                  
+2	2	+1	# ufpt_size_queue                         [0]       [nb_thread]                                  
 1	1	+1	# nb_decod_bloc                                                                           
 4	4	+1	# size_decod_queue                        [0]       [nb_decod_bloc]                              
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/src/main.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/SelfTest/src/main.cpp	(revision 97)
@@ -25,4 +25,5 @@
   err (_(" * ras_size_queue                          [nb_thread]                                  (uint32_t         )\n"));
   err (_(" * upt_size_queue                          [nb_thread]                                  (uint32_t         )\n"));
+  err (_(" * ufpt_size_queue                         [nb_thread]                                  (uint32_t         )\n"));
 
   err (_(" * nb_decod_bloc                                                                        (uint32_t         )\n"));
@@ -183,4 +184,5 @@
   uint32_t              * _ras_size_queue                                ;//[nb_thread]
   uint32_t              * _upt_size_queue                                ;//[nb_thread]
+  uint32_t              * _ufpt_size_queue                               ;//[nb_thread]
 
   // Decod_bloc
@@ -335,5 +337,5 @@
   SELFTEST0(_nb_thread                                     ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread))
     usage (argc, argv);
   
@@ -346,4 +348,5 @@
   SELFTEST1(_ras_size_queue                                ,uint32_t                ,argv,x,_nb_thread);
   SELFTEST1(_upt_size_queue                                ,uint32_t                ,argv,x,_nb_thread);
+  SELFTEST1(_ufpt_size_queue                               ,uint32_t                ,argv,x,_nb_thread);
 
   // Decod bloc
@@ -351,5 +354,5 @@
   SELFTEST0(_nb_decod_bloc                                 ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc))
     usage (argc, argv);
   
@@ -364,5 +367,5 @@
   SELFTEST0(_nb_rename_bloc                                ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc))
     usage (argc, argv);
   
@@ -382,5 +385,5 @@
   SELFTEST0(_nb_read_bloc                                  ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc))
     usage (argc, argv);
   
@@ -393,5 +396,5 @@
   SELFTEST0(_nb_write_bloc                                 ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc))
     usage (argc, argv);
   
@@ -404,5 +407,5 @@
   SELFTEST0(_nb_load_store_unit                            ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit))
     usage (argc, argv);
   
@@ -421,5 +424,5 @@
   SELFTEST0(_nb_functionnal_unit                           ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit))
     usage (argc, argv);
   
@@ -464,5 +467,5 @@
   SELFTEST0(_nb_front_end                                  ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end))
     usage (argc, argv);
   
@@ -491,5 +494,5 @@
   SELFTEST0(_nb_ooo_engine                                 ,uint32_t                ,argv,x);
   
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine))
     usage (argc, argv);
   
@@ -518,5 +521,5 @@
   SELFTEST0(_nb_execute_loop                               ,uint32_t                ,argv,x);
 
-  if (argc < static_cast<int>(2+NB_PARAMS+4*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop))
+  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+5*_nb_decod_bloc+10*_nb_rename_bloc+3*_nb_read_bloc+3*_nb_write_bloc+8*_nb_load_store_unit+1*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop))
     usage (argc, argv);
   
@@ -536,5 +539,5 @@
   printf(" * Link\n");
 
-  if (argc < static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop))
+  if (argc < static_cast<int>(2+NB_PARAMS+6*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop))
     usage (argc, argv);
   
@@ -590,5 +593,5 @@
     _sum_cache_port += _nb_cache_port[i];
   
-  if (argc != static_cast<int>(2+NB_PARAMS+5*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop+
+  if (argc != static_cast<int>(2+NB_PARAMS+6*_nb_thread+6*_nb_decod_bloc+11*_nb_rename_bloc+4*_nb_read_bloc+4*_nb_write_bloc+9*_nb_load_store_unit+2*_nb_functionnal_unit+31*_nb_front_end+18*_nb_ooo_engine+11*_nb_execute_loop+
                                3*_nb_thread+_nb_front_end+_sum_inst_issue*_nb_read_bloc+_nb_load_store_unit*(_nb_read_bloc+_nb_write_bloc+_nb_thread)+_nb_functionnal_unit*(_nb_read_bloc+_nb_write_bloc)+_sum_cache_port))
     usage (argc, argv);
@@ -626,4 +629,5 @@
          _ras_size_queue                                ,
          _upt_size_queue                                ,
+         _ufpt_size_queue                               ,
 
          _nb_decod_bloc                                 ,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/include/Parameters.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/include/Parameters.h	(revision 97)
@@ -46,4 +46,5 @@
   public : uint32_t              * _ras_size_queue                                ;//[nb_thread]
   public : uint32_t              * _upt_size_queue                                ;//[nb_thread]
+  public : uint32_t              * _ufpt_size_queue                               ;//[nb_thread]
 
   // Decod bloc
@@ -221,4 +222,5 @@
   public : uint32_t             ** _front_end_ras_size_queue                      ;//[nb_front_end][nb_context]
   public : uint32_t             ** _front_end_upt_size_queue                      ;//[nb_front_end][nb_context]
+  public : uint32_t             ** _front_end_ufpt_size_queue                     ;//[nb_front_end][nb_context]
 
   // translate for ooo_engine
@@ -346,4 +348,5 @@
   uint32_t              * ras_size_queue                                ,//[nb_thread]
   uint32_t              * upt_size_queue                                ,//[nb_thread]
+  uint32_t              * ufpt_size_queue                               ,//[nb_thread]
 
   // Decod bloc
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 97)
@@ -84,4 +84,5 @@
   uint32_t              * ras_size_queue                                ,//[nb_thread]
   uint32_t              * upt_size_queue                                ,//[nb_thread]
+  uint32_t              * ufpt_size_queue                               ,//[nb_thread]
 
   // Decod bloc
@@ -237,4 +238,5 @@
     _ras_size_queue                          = ras_size_queue                          ;
     _upt_size_queue                          = upt_size_queue                          ;
+    _ufpt_size_queue                         = ufpt_size_queue                         ;
 
     _nb_decod_bloc                           = nb_decod_bloc                           ;
@@ -441,4 +443,5 @@
     ALLOC2(_front_end_ras_size_queue                      ,uint32_t         ,_nb_front_end,_nb_context[it1]);
     ALLOC2(_front_end_upt_size_queue                      ,uint32_t         ,_nb_front_end,_nb_context[it1]);
+    ALLOC2(_front_end_ufpt_size_queue                     ,uint32_t         ,_nb_front_end,_nb_context[it1]);
 
     for (uint32_t i=0; i<_nb_front_end; ++i)
@@ -451,4 +454,5 @@
           _front_end_ras_size_queue               [i][j] = _ras_size_queue    [num_thread];
           _front_end_upt_size_queue               [i][j] = _upt_size_queue    [num_thread];
+          _front_end_ufpt_size_queue              [i][j] = _ufpt_size_queue   [num_thread];
 
           uint32_t num_decod_bloc = _link_decod_bloc_with_thread [num_thread];
@@ -1733,4 +1737,5 @@
         _front_end_ras_size_queue               [i],
         _front_end_upt_size_queue               [i],
+        _front_end_ufpt_size_queue              [i],
         _size_nb_inst_commit                    
         );
@@ -2027,4 +2032,5 @@
     DELETE1(_front_end_nb_inst_branch_complete                      ,_nb_front_end);
     DELETE3(_front_end_instruction_implemeted                       ,_nb_front_end,_nb_context[it1],NB_INSTRUCTION);
+    DELETE2(_front_end_ufpt_size_queue                              ,_nb_front_end,_nb_context[it1]);
     DELETE2(_front_end_upt_size_queue                               ,_nb_front_end,_nb_context[it1]);
     DELETE2(_front_end_ras_size_queue                               ,_nb_front_end,_nb_context[it1]);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_print.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters_print.cpp	(revision 97)
@@ -43,4 +43,5 @@
     str+= toString(MSG_INFORMATION)+"     * ras_size_queue                              : "+toString<uint32_t>(_ras_size_queue    [i])+"\n";
     str+= toString(MSG_INFORMATION)+"     * upt_size_queue                              : "+toString<uint32_t>(_upt_size_queue    [i])+"\n";
+    str+= toString(MSG_INFORMATION)+"     * ufpt_size_queue                             : "+toString<uint32_t>(_ufpt_size_queue   [i])+"\n";
     
     for (uint32_t j=0; j<NB_GROUP; ++j)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_vhdl_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_vhdl_declaration.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Monolithic/src/RegisterFile_Monolithic_vhdl_declaration.cpp	(revision 97)
@@ -18,5 +18,5 @@
   void RegisterFile_Monolithic::vhdl_declaration (Vhdl * & vhdl)
   {
-    vhdl->set_type ("Tregfile", "array " + std_logic_range(_param->_nb_word,true) + " of " + std_logic(_param->_size_word));
+    vhdl->set_type ("Tregfile", "array " + _std_logic_range(_param->_nb_word) + " of " + std_logic(_param->_size_word));
 
     vhdl->set_signal ("reg_DATA", "Tregfile");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/include/test.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/SelfTest/include/test.h	(revision 97)
@@ -16,4 +16,5 @@
 
 #include "Behavioural/Generic/RegisterFile/RegisterFile_Multi_Banked/include/RegisterFile_Multi_Banked.h"
+#include "Common/include/Time.h"
 
 using namespace std;
@@ -28,34 +29,2 @@
 	      morpheo::behavioural::generic::registerfile::registerfile_multi_banked::Parameters * param);
 
-
-class Time 
-{
-private : timeval time_begin;
-// private : timeval time_end;
-  
-public  : Time ()
-  {
-    gettimeofday(&time_begin     ,NULL);
-  };
-
-public  : ~Time ()
-  {
-    cout << *this;
-  };
-
-public  : friend ostream& operator<< (ostream& output_stream,
-				      const Time & x)
-  {
-    timeval time_end;
-    
-    gettimeofday(&time_end       ,NULL);
-    
-    uint32_t nb_cycles = static_cast<uint32_t>(sc_simulation_time());
-
-    double average = static_cast<double>(nb_cycles) / static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec);
-    
-    output_stream << nb_cycles << "\t(" << average << " cycles / seconds )" << endl;
-
-    return output_stream;
-  }
-};
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/include/test.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/include/test.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/include/test.h	(revision 97)
@@ -15,4 +15,5 @@
 
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
+#include "Common/include/Time.h"
 
 using namespace std;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/src/test.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/SelfTest/src/test.cpp	(revision 97)
@@ -94,4 +94,5 @@
 
   cout << "<" << name << "> Start Simulation ............" << endl;
+  Time * _time = new Time();
 
   if (_param->_nb_entity > (8*sizeof (Tentity_t)))
@@ -148,4 +149,5 @@
    ********************************************************/
 
+  delete    _time;
   cout << "<" << name << "> ............ Stop Simulation" << endl;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 97)
@@ -52,5 +52,5 @@
 
 #ifdef VHDL
-    if (usage_is_set(_usage,USE_VHDL)
+    if (usage_is_set(_usage,USE_VHDL))
       {
         // generate the vhdl
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Common
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Common	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Makefile.Common	(revision 97)
@@ -27,5 +27,4 @@
 DIR_SRC				= src
 DIR_OBJ				= obj
-#DIR_LIB				= $(DIR_TMP)/lib
 DIR_SCRIPT			= $(MORPHEO_SCRIPT)
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Constants.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Constants.h	(revision 96)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/include/Constants.h	(revision 97)
@@ -16,4 +16,6 @@
   [0][19] - SPR_CID
 */
+
+#include "Common/include/ToString.h"
 
 namespace morpheo {
@@ -33,16 +35,19 @@
 
   //=========================================================[ Type ]=====
-#  define TYPE_ALU                                 0x0        // 00000 - unit multiple
-#  define TYPE_SHIFT                               0x1        // 00000 - unit multiple
-#  define TYPE_MOVE                                0x2        // 00000 - unit multiple
-#  define TYPE_TEST                                0x3        // 00000 - unit multiple
-#  define TYPE_MUL                                 0x4        // 00000 - unit multiple
-#  define TYPE_DIV                                 0x5        // 00000 - unit multiple, type optionnal
-#  define TYPE_EXTEND                              0x6        // 00000 - unit multiple, type optionnal
-#  define TYPE_FIND                                0x7        // 00000 - unit multiple, type optionnal
-#  define TYPE_SPECIAL                             0x8        // 00000 - unit uniq
-#  define TYPE_CUSTOM                              0x9        // 00000 - unit uniq    , type optionnal
-#  define TYPE_BRANCH                              0xa        // 00000 - unit multiple
-#  define TYPE_MEMORY                              0xb        // 00000 - unit uniq
+typedef enum
+  {
+    TYPE_ALU                               = 0x0,       // 00000 - unit multiple
+    TYPE_SHIFT                             = 0x1,       // 00000 - unit multiple
+    TYPE_MOVE                              = 0x2,       // 00000 - unit multiple
+    TYPE_TEST                              = 0x3,       // 00000 - unit multiple
+    TYPE_MUL                               = 0x4,       // 00000 - unit multiple
+    TYPE_DIV                               = 0x5,       // 00000 - unit multiple, type optionnal
+    TYPE_EXTEND                            = 0x6,       // 00000 - unit multiple, type optionnal
+    TYPE_FIND                              = 0x7,       // 00000 - unit multiple, type optionnal
+    TYPE_SPECIAL                           = 0x8,       // 00000 - unit uniq
+    TYPE_CUSTOM                            = 0x9,       // 00000 - unit uniq    , type optionnal
+    TYPE_BRANCH                            = 0xa,       // 00000 - unit multiple
+    TYPE_MEMORY                            = 0xb        // 00000 - unit uniq
+  } type_t;
 
 //#define NB_TYPE                                  11
@@ -610,13 +615,48 @@
 
 #  define SIZE_BRANCH_CONDITION                    4
-
-#  define BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK          0x0        // None condition (jump)
-#  define BRANCH_CONDITION_NONE_WITH_WRITE_STACK             0x8        // None condition (jump)
-#  define BRANCH_CONDITION_FLAG_UNSET                        0x2        // Branch if Flag is clear
-#  define BRANCH_CONDITION_FLAG_SET                          0x3        // Branch if Flag is set
-#  define BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK 0x4        // Branch if a register is read
-#  define BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK    0xc        // Branch if a register is read
-#  define BRANCH_CONDITION_READ_STACK                        0xf        // Branch with pop  in stack pointer
-
+#  define MAX_BRANCH_CONDITION                     (1<<SIZE_BRANCH_CONDITION)
+  typedef enum
+    {
+      BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK          = 0x0,        // None condition (jump)
+      BRANCH_CONDITION_NONE_WITH_WRITE_STACK             = 0x8,        // None condition (jump)
+      BRANCH_CONDITION_FLAG_UNSET                        = 0x2,        // Branch if Flag is clear
+      BRANCH_CONDITION_FLAG_SET                          = 0x3,        // Branch if Flag is set
+      BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK = 0x4,        // Branch if a register is read
+      BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK    = 0xc,        // Branch if a register is read
+      BRANCH_CONDITION_READ_STACK                        = 0xf         // Branch with pop  in stack pointer
+    } branch_condition_t;
+
+#  define is_branch_condition_valid(x)                           \
+  (( x == BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK         ) or \
+   ( x == BRANCH_CONDITION_NONE_WITH_WRITE_STACK            ) or \
+   ( x == BRANCH_CONDITION_FLAG_UNSET                       ) or \
+   ( x == BRANCH_CONDITION_FLAG_SET                         ) or \
+   ( x == BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK) or \
+   ( x == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK   ) or \
+   ( x == BRANCH_CONDITION_READ_STACK                       ))
+
+
+  /*
+enum
+  {
+    BRANCH_TYPE_SEQUENTIAL,
+    BRANCH_TYPE_JUMP,
+    BRANCH_TYPE_CONDITIONNAL,
+    BRANCH_TYPE_REGISTER,
+    BRANCH_TYPE_CALL,
+    BRANCH_TYPE_RETURN,
+    NB_BRANCH_TYPE
+  };
+
+#  define branch_condition_to_type(x)                                   \
+  (x == BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK         )?BRANCH_TYPE_JUMP: \
+  ((x == BRANCH_CONDITION_NONE_WITH_WRITE_STACK            )?BRANCH_TYPE_CALL: \
+   ((x == BRANCH_CONDITION_FLAG_UNSET                       )?BRANCH_TYPE_CONDITIONNAL: \
+    ((x == BRANCH_CONDITION_FLAG_SET                         )?BRANCH_TYPE_CONDITIONNAL: \
+     ((x == BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK)?BRANCH_TYPE_REGISTER: \
+      ((x == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK   )?BRANCH_TYPE_CALL: \
+       ((x == BRANCH_CONDITION_READ_STACK                       )?BRANCH_TYPE_RETURN:BRANCH_TYPE_SEQUENTIAL))))));
+  */
+  
   //--------------------------------------------------[ instruction ]-----
 #  define NB_INSTRUCTION                           213        // 92 ORBIS, 30 ORFPX (15 simple, 15 double), 91 ORVDX (38 on byte, 41 on half, 12 independant format)
@@ -991,4 +1031,40 @@
 
 }; // end namespace behavioural
+
+  template<> inline std::string toString<morpheo::behavioural::type_t>(const morpheo::behavioural::type_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::TYPE_ALU     : return "ALU"        ;
+      case morpheo::behavioural::TYPE_SHIFT   : return "SHIFT"      ;
+      case morpheo::behavioural::TYPE_MOVE    : return "MOVE"       ;
+      case morpheo::behavioural::TYPE_TEST    : return "TEST"       ;
+      case morpheo::behavioural::TYPE_MUL     : return "MUL"        ;
+      case morpheo::behavioural::TYPE_DIV     : return "DIV"        ;
+      case morpheo::behavioural::TYPE_EXTEND  : return "EXTEND"     ;
+      case morpheo::behavioural::TYPE_FIND    : return "FIND"       ;
+      case morpheo::behavioural::TYPE_SPECIAL : return "SPECIAL"    ;
+      case morpheo::behavioural::TYPE_CUSTOM  : return "CUSTOM"     ;
+      case morpheo::behavioural::TYPE_BRANCH  : return "BRANCH"     ;
+      case morpheo::behavioural::TYPE_MEMORY  : return "MEMORY"     ;
+      default : return "";
+      }
+  };
+
+  template<> inline std::string toString<morpheo::behavioural::branch_condition_t>(const morpheo::behavioural::branch_condition_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::BRANCH_CONDITION_NONE_WITHOUT_WRITE_STACK          : return "none_without_write_stack"         ;
+      case morpheo::behavioural::BRANCH_CONDITION_NONE_WITH_WRITE_STACK             : return "none_with_write_stack"            ;
+      case morpheo::behavioural::BRANCH_CONDITION_FLAG_UNSET                        : return "flag_unset"                       ;
+      case morpheo::behavioural::BRANCH_CONDITION_FLAG_SET                          : return "flag_set"                         ;
+      case morpheo::behavioural::BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK : return "read_register_without_write_stack";
+      case morpheo::behavioural::BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK    : return "read_register_with_write_stack"   ;
+      case morpheo::behavioural::BRANCH_CONDITION_READ_STACK                        : return "read_stack"                       ;
+      default : return "";
+      }
+  };
+
 }; // end namespace morpheo              
 
